#include "ProcessorManual.h"
#include <iostream>

namespace mdd {
    ProcessorManual::ProcessorManual()
    {
        addProcessorOutput("Iterator", "{ \"value\": 0 }"_json);
    }

    state ProcessorManual::update() {
        state ret = state::UNCHANGED;
        state group_state = state::CHANGED;
        while(group_state == state::CHANGED){
            getProcessorOutput(0)->getValueInternal()["value"]= getProcessorOutput(0)->getValue()["value"].get<int>()+1;
            group_state = state::UNCHANGED;
            for (int i = 0; i < getModules().size(); ++i) {
                state module_state = getModule(i)->update();
                if(module_state == state::CHANGED){
                    group_state = state::CHANGED;
                    ret = state::CHANGED;
                }
            }
        }
        return ret;
    }

    std::shared_ptr<IOutput> ProcessorManual::getIteration(){
        return getProcessorOutput(0);
    }
}